<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Danh sách người dùng</title>

   <!-- Google Font: Source Sans Pro -->
   <link rel="stylesheet"
   href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">

  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  
  <!-- Select2 -->
  <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
  <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini layout-fixed">
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">User list</a>
      </li>
    </ul>

    <!-- Right navbar links -->
    <ul class="navbar-nav ml-auto">
      <li class="nav-item">
        <a class="nav-link" data-widget="fullscreen" href="#" role="button">
          <i class="fas fa-expand-arrows-alt"></i>
        </a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index.html" class="brand-link">
      <span class="brand-text font-weight-light">Devcamp</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
               <li class="nav-item">
                <a href="index.html" class="nav-link">
                    <i class="nav-icon fas fa-th"></i>
                    <p>
                      Quản lý bảng điểm
                    </p>
                </a>
            </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Danh sách bảng điểm</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Grade list</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-sm-12 text-center">
            <h3>
              F-200 LỊCH SỬ HỌC TẬP
            </h3>
          </div>
        </div>
        <div class="jumbotron">
          <h4 class="form-group"><b>Lọc bảng điểm:</b></h4>
          <div class="row">
            <div class="col-sm-2 form-group">
              <label>Sinh viên</label>
            </div>
            <div class="col-sm-3 form-group">
              <select  class="form-control select2 select2-primary" name="select-student" id="select-student" style="width: 100%;">
              </select>
            </div>
            <div class="col-sm-2 form-group">
              <label>Môn học</label>
            </div>
            <div class="col-sm-3 form-group">
              <select class="form-control select2 select2-primary" name="select-subject" id="select-subject" style="width: 100%;">

              </select>
            </div>
            <div class="col-sm-2 form-group">
              <button id="btn-filter" class="btn btn-success"><i class="fas fa-search"></i>&nbsp;Lọc</button>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col-12 form-group">
            <button id="btn-create-grade" class="btn btn-success"><i class="fas fa-plus"></i>&nbsp; Thêm mới</button>  
          </div>
        </div>
        <table class="table table-bordered table-striped table-hover table-primary" id="table-students">
          <thead class="bg-primary">
              <tr>
                  <th>STT</th>
                  <th>Sinh viên</th>
                  <th>Môn học</th>
                  <th>Điểm</th>
                  <th>Ngày thi</th>
                  <th>Actions</th>
              </tr>
          </thead>
          <tbody>
          </tbody>
      </table>
       <!-- Modal Grades Create-->
       <div>
        <div class="modal fade" id="modal-create-grade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Thêm Thông tin điểm</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4">ID Học sinh</label>
                                <div class="col-sm-8">
                                    <input type="text" class="form-control" id="modal-create-inp-studentid">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4">ID Môn học</label>
                                <div class="col-sm-8">
                                    <input type="text" class="form-control" id="modal-create-inp-subjectid">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4">Diểm</label>
                                <div class="col-sm-8">
                                    <input type="text" class="form-control" id="modal-create-inp-grades">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4">Ngày làm bài</label>
                                <div class="col-sm-8">
                                    <input type="text" class="form-control" id="modal-create-inp-date-exam">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary"
                            data-dismiss="modal">Hủy bỏ</button>
                            <button id="modal-btn-create" type="button" class="btn btn-success"
                            data-dismiss="modal"><i class="fas fa-plus"></i></i>&nbsp; Thêm mới</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
      <!-- Modal Grades Edit-->
      <div>
        <div class="modal fade" id="modal-edit-grade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title">Sửa Thông tin điểm</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4">ID Học sinh</label>
                                <div class="col-sm-8">
                                    <input type="text" class="form-control" id="modal-inp-studentid">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4">ID Môn học</label>
                                <div class="col-sm-8">
                                    <input type="text" class="form-control" id="modal-inp-subjectid">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4">Diểm</label>
                                <div class="col-sm-8">
                                    <input type="text" class="form-control" id="modal-inp-grades">
                                </div>
                            </div>
                            <div class="row form-group">
                                <label class="col-form-label col-sm-4">Ngày làm bài</label>
                                <div class="col-sm-8">
                                    <input type="text" class="form-control" id="modal-inp-date-exam">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary"
                            data-dismiss="modal">Hủy bỏ</button>
                            <button id="modal-btn-edit" type="button" class="btn btn-success"
                            data-dismiss="modal"><i class="fas fa-edit"></i>&nbsp; Sửa</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
     <!-- Modal Grades Delete-->
    <div>
      <div class="modal fade" id="modal-delete-grade" tabindex="-1">
          <div class="modal-dialog">
              <div class="modal-content">
                  <div class="modal-header">
                      <h5 class="modal-title">Xóa Thông Tin Điểm</h5>
                      <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                          <span aria-hidden="true">&times;</span>
                      </button>
                  </div>
                  <div class="modal-body">
                      <form>
                          <p>Bạn có chắc chắn muốn xóa thông tin diểm này không?</p>
                      </form>
                  </div>
                  <div class="modal-footer">
                      <button type="button" class="btn btn-secondary"
                          data-dismiss="modal">Hủy bỏ</button>
                          <button id="modal-btn-delete" type="button" class="btn btn-danger"
                          data-dismiss="modal">Xoá</button>
                  </div>
              </div>
          </div>
      </div>
  </div>
      </div>
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="https://adminlte.io">AdminLTE.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.2.0
    </div>
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->
<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.js"></script>

<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- Select2 -->
<script src="plugins/select2/js/select2.full.min.js"></script>

</body>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";
    var gStudentList = "";
    var gSubjectList = "";
    var gGrades = "";
    var gGradeId = 0;
    var gStt = 0;
    const gDATA_COLUMN = ["stt","sinhvien","monhoc","ngaythi","actions"];
    const gSTT_COL = 0;
    const gSINH_VIEN_COL = 1;
    const gMON_HOC_COL = 2;
    const gDIEM_COL = 3;
    const gNGAY_THI_COL = 4;
    const gACTIONS_COL = 5;
    var gTableStudent = $("#table-students").DataTable({
      columns:[
        { data:gDATA_COLUMN[gSTT_COL] },
        { data:gDATA_COLUMN[gSINH_VIEN_COL] },
        { data:gDATA_COLUMN[gMON_HOC_COL] },
        { data:gDATA_COLUMN[gDIEM_COL] },
        { data:gDATA_COLUMN[gNGAY_THI_COL] },
        { data:gDATA_COLUMN[gACTIONS_COL] },
      ],
      columnDefs:[
        {
          targets: gSTT_COL,
          render:function(data){
            return gStt+=1;
          }
        },
        {
          targets: gSINH_VIEN_COL,
          render:function(data,type,row,meta){
            return getStudentName(row.studentId);
          }
        },
        {
          targets: gMON_HOC_COL,
          render:function(data,type,row,meta){
            return getSubjectName(row.subjectId);
          }
        },
        {
          targets: gDIEM_COL,
          render:function(data,type,row,meta){
            return row.grade;
          }
        },
        {
          targets: gNGAY_THI_COL,
          render:function(data,type,row,meta){
            return row.examDate;
          }
        },
        {
          targets:gACTIONS_COL,
          render:function(data,type,row,meta){
            return `<i id="btn-edit" data-id="${row.id}" style="cursor: pointer;" class="fas fa-edit fa-lg"></i>&nbsp;&nbsp;&nbsp;<i id="btn-delete" data-id="${row.id}" style="cursor: pointer;" class="fas fa-trash-alt fa-lg"></i>`
          }
        },
      ]
    })
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    //Jquery xử lý sự kiện load trang
    $(document).ready(function(){
      //Gọi ajax lấy thông tin sinh viên
      callAJAXGetStudentList();
      //Gọi ajax lấy thông tin môn học
      callAJAXGetSubjectList();
      //Gọi ajax lấy điểm môn học
      callAJAXGetGradeList();
    })
    //Tạo xử lý sự kiện ăn nút cho nút lọc
    $("#btn-filter").on("click",onBtnFilterClick);
     //Tạo xử lý sự kiện ăn nút cho nút thêm mới
     $("#btn-create-grade").on("click",onBtnCreateGradeClick);
    //Tạo xử lý sự kiện ăn nút cho nút sửa
    $(document).on("click","#btn-edit",onBtnEditGradeClick);
    //Tạo xử lý sự kiện ăn nút cho nút xóa
    $(document).on("click","#btn-delete",onBtnDeleteGradeClick);
    //Tạo xử lý sự kiện ăn nút cho nút xóa modal
    $("#modal-btn-delete").on("click",onModalBtnDeleteGradeClick);
    //Tạo xử lý sự kiện ăn nút cho nút sửa modal
    $("#modal-btn-edit").on("click",onBtnModalEditGradeClick);
     //Tạo xử lý sự kiện ăn nút cho nút sửa modal
     $("#modal-btn-create").on("click",onBtnModalCreateGradeClick);
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
    //Hàm xử lý khi ắn nút modal thêm mới
    function onBtnModalCreateGradeClick(){
      "use strict";
      //B1:Tạo hướng đối tượng và thu thập thông tin
      var vGradeData = {
            studentId: 0,
            subjectId: 0,
            grade: 0,
            examDate: ""
      }
      getDataGradesFormModalCreateInput(vGradeData);
      //console.log(vGradeData)
      var vCheck = validateData(vGradeData);
      if(vCheck){
        callAjaxCreateGrade(vGradeData);
      }
    }
    //Hàm xữ lý khi ăn nút thêm mới
    function onBtnCreateGradeClick(){
      "use strict";
      $("#modal-create-grade").modal("show");
    } 
    // Hảm xử lý khi ăn nút sữa
    function onBtnEditGradeClick(){
      "use strict";
      gGradeId = $(this).data("id");
      getDataGradesToInput();
      //Lấy thông tin điểm lên input
      $("#modal-edit-grade").modal("show");
      
    }
     // Hảm xử lý khi ăn nút sửa
     function onBtnModalEditGradeClick(){
      "use strict";
      var vGradeData = {
            studentId: 0,
            subjectId: 0,
            grade: 0,
            examDate: ""
      }
     getDataGradesFormInput(vGradeData);
     var vCheck = validateData(vGradeData);
     //console.log(vGradeData);
     //Cập nhật thông tin điểm
     if(vCheck){
      callAjaxUpdateGrade(vGradeData);
     }
    }
    //Hàm xử lý sự kiện khi ắn nút xóa trên modal
     function onModalBtnDeleteGradeClick(){
      "use strict";
      callAjaxDeleteGrades(gGradeId);
     }
    // Hảm xử lý khi ăn nút xóa
    function onBtnDeleteGradeClick(){
      "use strict";
      $("#modal-delete-grade").modal("show");
      gGradeId = $(this).data("id");
      //console.log(vId)
      //Gọi ajax xóa thông tin điểm
    }
    // Hảm xử lý khi ăn nút lọc
    function onBtnFilterClick(){
      "use strict";
      var vFilterResult = filterStudentAndSubjectData();
      //console.log(vFilterResult);
      displayInDataTableStudent(vFilterResult);

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm thêm mới thông tin điẻm
    function callAjaxCreateGrade(paramData){
      "use strict";
      $.ajax({
        url:gBASE_URL + "/grades",
        type:"POST",
        contentType:"application/json",
        data:JSON.stringify(paramData),
        success:function(responseObject){
          alert("Cập nhật thành công thông tin điểm:\n" + JSON.stringify(responseObject));
          callAJAXGetGradeList();
        },
        error:function(ajaxContext){
          alert(ajaxContext.responseText);
        }
      })
    }
    //Hàm kiểm tra thông tin nhập vào
    function validateData(paramData){
      "use strict";
      var vResult = true;
      var vStudentId = paramData.studentId;
      var vSubjectId = paramData.subjectId;
      var vGrade = paramData.grade;
      var vExamDate = paramData.examDate;
      if(vStudentId == ""){
        alert("Hãy nhập id sinh viên!");
        vResult = false;
      } else if(isNaN(vStudentId)){
        alert("Id sinh viên phải là số!");
        vResult = false;
      } else if(vSubjectId == ""){
        alert("Hãy nhập id môn học!");
        vResult = false;
      } else if(isNaN(vSubjectId)){
        alert("Id môn học phải là số!");
        vResult = false;
      } else if(vGrade == ""){
        alert("Hãy nhập số điểm!");
        vResult = false;
      } else if(vGrade > 10){
        alert("Điểm không được lớn hơn 10!");
        vResult = false;
      } else if(vExamDate == ""){
        alert("Hãy nhập ngày làm bài!");
        vResult = false;
      }
      return vResult;
    }
    //Hàm lấy thông tin từ modal thêm mới
    function getDataGradesFormModalCreateInput(paramData){
      "use strict";
      paramData.studentId = $("#modal-create-inp-studentid").val().trim();
      paramData.subjectId = $("#modal-create-inp-subjectid").val().trim();
      paramData.grade = $("#modal-create-inp-grades").val().trim();
      paramData.examDate = $("#modal-create-inp-date-exam").val().trim();
    }
    //Hàm gọi ajax cập nhật thông tin điểm
    function callAjaxUpdateGrade(paramData){
      "use strict";
      $.ajax({
        url:gBASE_URL + "/grades/" + gGradeId,
        type:"PUT",
        contentType:"application/json",
        data:JSON.stringify(paramData),
        success:function(){
          alert("Cập nhật thành công thông tin diểm có Id là : " + gGradeId);
          callAJAXGetGradeList();
        },
        error:function(ajaxContext){
          alert(ajaxContext.responseText);
        }
      })
    }
    //Hàm lấy thông tin từ input
    function getDataGradesFormInput(paramData){
      "use strict";
      paramData.studentId = $("#modal-inp-studentid").val();
      paramData.subjectId = $("#modal-inp-subjectid").val();
      paramData.grade = $("#modal-inp-grades").val();
      paramData.examDate = $("#modal-inp-date-exam").val();
    }
    //Hàm lấy thông tin lên modal sửa
    function getDataGradesToInput(){
      "use strict";
      var vResult = "";
      $.each(gGrades,function(key,value){
        if(value.id == gGradeId){
          $("#modal-inp-studentid").val(value.studentId);
          $("#modal-inp-subjectid").val(value.subjectId);
          $("#modal-inp-grades").val(value.grade);
          $("#modal-inp-date-exam").val(value.examDate);
        }
      })
    }
    //Hàm gọi ajax ajax xóa thông tin điểm
    function callAjaxDeleteGrades(paramId){
      "use strict";
      $.ajax({
        url:gBASE_URL + "/grades/" + paramId,
        type:"DELETE",
        success:function(){
          alert("Delete Điểm có id là " + paramId + " thành công!");
          callAJAXGetGradeList();
        },
        error:function(ajaxContext){
          alert(ajaxContext.responseText);
        }
      })
    }
    //Hảm lọc dữ liệu
    function filterStudentAndSubjectData(){
      "use strict";
      var vStudentId = $("#select-student").val();
      var vSubjectId = $("#select-subject").val();
      return gGrades.filter(function(grade){
        return grade.studentId == vStudentId && grade.subjectId == vSubjectId
      })
    }
    //Hảm hiển thị lên datatable 
    function displayInDataTableStudent(paramData){
      "use strict";
      gStt = 0;
      gTableStudent.clear();
      gTableStudent.rows.add(paramData);
      gTableStudent.draw();
    }
    //Hàm gọi ajax lấy điểm môn học
    function callAJAXGetGradeList(){
      "use strict";
      $.ajax({
        url:gBASE_URL + "/grades",
        type:"GET",
        dataType:"json",
        
        success:function(responseObject){
          //console.log(responseObject)
          gGrades = responseObject;
          //Hiển thị lên datatable 
          displayInDataTableStudent(responseObject)
        },
        error:function(ajaxContext){
          alert(ajaxContext.responseText);
        }
      })
    }
    //Hàm lấy tên môn học
    function getSubjectName(paramId){
      "use strict";
      var vResult = "";
      $.each(gSubjectList,function(key,value){
        if(value.id == paramId){
          vResult = value.subjectName;
        }
      })
      return vResult;
     }
     //Hàm lấy tên học sinh
     function getStudentName(paramId){
      "use strict";
      var vResult = "";
      $.each(gStudentList,function(key,value){
        if(value.id == paramId){
          vResult = value.firstname + " " + value.lastname;
        }
      })
      return vResult;
     }
     //Hảm hiển thị thông tin trên ô select của học sinh
     function displayInSubjectSelect(paramData){
      "use strict";
      $.each(paramData,function(key,value){
        $("#select-subject").append($("<option\>",{
          value:value.id,
          text:value.subjectName
        })
          )
      })
     }
    //Hảm gọi ajax lấy thông tin môn học
    function callAJAXGetSubjectList(){
      "use strict";
      $.ajax({
        url:gBASE_URL + "/subjects",
        type:"GET",
        dataType:"json",
        async:false,
        success:function(responseObject){
          gSubjectList = responseObject;
          //console.log(gSubjectList)
          //Hiển thị lên ô select của học sinh
          displayInSubjectSelect(responseObject)
        },
        error:function(ajaxContext){
          alert(ajaxContext.responseText);
        }
      })
    }
    //Hảm hiển thị thông tin trên ô select của học sinh
    function displayInStudentSelect(paramData){
      "use strict";
      $.each(paramData,function(key,value){
        $("#select-student").append($("<option\>",{
          value:value.id,
          text:value.firstname + " " + value.lastname
        })
          )
      })
    }
    //Hàm gọi ajax lấy thông tin sinh viên
    function callAJAXGetStudentList(){
      "use strict";
      $.ajax({
        url:gBASE_URL + "/students",
        type:"GET",
        dataType:"json",
        async:false,
        success:function(responseObject){
          //console.log(responseObject)
          gStudentList = responseObject;
          //Hiển thị lên ô select của học sinh
          displayInStudentSelect(responseObject)
        },
        error:function(ajaxContext){
          alert(ajaxContext.responseText);
        }
      })
    }
    //Hàm thay đổi giao diện cho input có class select2
    $(function () {
    //Initialize Select2 Elements
    $('.select2').select2({
      theme: 'bootstrap4'
    })
     })
  </script>
</html>
